#ifndef DEFINES_H
#define DEFINES_H

#define MIN2(a,b) ((a) <= (b) ? (a) : (b))
#define MAX2(a,b) ((a) >= (b) ? (a) : (b))

#ifndef TRUE
#define TRUE 1
#endif

#ifndef FALSE
#define FALSE 0
#endif

#define RMP_DEFAULT_GROUP_NAME "MultiTCP"

#define FOREVER for(;;)

#define TIME_GET(x)           (gettimeofday(x, (struct timezone*)NULL))
#define TIME_DIFF_SEC(a,b)    (b.tv_sec -a.tv_sec )
#define TIME_DIFF_USEC(a,b)   (b.tv_usec-a.tv_usec)
#define TIME_DIFF_ULONG(a,b)  (((unsigned long)(TIME_DIFF_SEC(a,b)*1000000))+((unsigned long)TIME_DIFF_USEC(a,b)))
#define TIME_DIFF_DOUBLE(a,b) (((double)TIME_DIFF_SEC(a,b))+(((double)TIME_DIFF_USEC(a,b))*0.000001))

typedef unsigned char         COMMAND;
#define CMD(x)                ((COMMAND)x)

#define CMD_CONNECT           CMD(0)
#define CMD_SOCKET_ACK        CMD(1)
#define CMD_CLOSE             CMD(2)
#define CMD_BEGIN_MESSAGE     CMD(3)
#define CMD_END_MESSAGE       CMD(4)
#define CMD_MESSAGE_ACK       CMD(5)
#define CMD_GET_SOCK_NAME     CMD(6)
#define CMD_GET_SOCK_OPT      CMD(7)
#define CMD_SET_SOCK_OPT      CMD(8)
#define CMD_ACCEPT            CMD(9)
#define CMD_BIND              CMD(10)
#define CMD_IPC_ACK           CMD(11)
#define CMD_FORK              CMD(12)
#define CMD_FORK_ACK          CMD(13)
#define CMD_ACCEPT_REQ        CMD(14)

#define RMP_MEMBER            0
#define RMP_OUTCAST           1

#define CONNECTION_IPC        0
#define CONNECTION_SOCKET     1

#endif
